!IF "$(PROJECT)"=="" || "$(TARGETS)"==""
!ERROR Missing PROJECT or TARGETS
!ENDIF

DIST_DIR=..\..\bin\$(TYPE)

!UNDEF TYPE

!IFDEF NODEBUG
TYPE=Release
!ELSE
TYPE=Debug
!ENDIF

!UNDEF MAKE_LINE

MAKE_LINE=$(MAKE) /$(MAKEFLAGS) /f $(PROJECT).mak CFG="$(PROJECT) - Win32 $(TYPE)" $(USERFLAGS)

all:
	$(MAKE_LINE)

clean:
	$(MAKE_LINE) clean
	-@for %%a in ( obj\$(TYPE)\$(PROJECT).pch ) do @if exist %%a erase %%a
	-@for %%a in ( obj\$(TYPE) obj ) do @if exist %%a rmdir %%a

dist: all $(DIST_DIR)
	@for %%a in ($(TARGETS)) do @( copy obj\$(TYPE)\%%a $(DIST_DIR)\. )

$(DIST_DIR):
	mkdir $(DIST_DIR)

help:
	@echo Define NODEBUG to get release targets
	@echo Otherwise, you will get debug targets
	@echo nmake all - builds binaries (default)
	@echo nmake dist - copies binaries
	@echo nmake clean - removes binaries
	@echo nmake help - prints this message
